// for global g@ keypress
var jemhGlobalAdHocFunctionPointer;
var jemhGlobalAdHocSessionId;
function handleGlobalJemhAdHocNotificationClick() {
	//select the issue
	jemhGlobalAdHocFunctionPointer();
}
var jemhAdHocPopupActive=false;

var jemhOrderedAlphabetically=false;
var jemhOrderedId=false;
AJS.$(document).ready( function(){
	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
    var lastClick=0;
    var subjectEditor;
    var contentEditor;
    var tinyMceEditor;
    var issueKey;
	var aceLoaded=false;
	var dataTableLoaded=false;
	var shouldUpdateToRecipient=true;
	var shouldUpdateCcRecipient=true;
	var shouldUpdateBccRecipient=true;

    var aceSetup=false;
    var tinymceSetup=false;
    var adhocSessionId; //for uploads
    var tinyMceUploadUrl;

    var dialog;
    var oneup=0; //for delete

    function htmlEncode(value){
   	  return $('<div/>').text(value).html();
   	}

	function showPreview(editor, editWrapperDivId, previewWrapperDivId, showTypeAs) {
	  	console.log("Showing preview");
	  	AJS.$(editWrapperDivId).hide();
	  	AJS.$(previewWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("Rendering, please wait");
	  	//AJAX POST of content to render

	  	AJS.$("#testIssueKey").val(issueKey);
	  	if ( editor==contentEditor) {
	  		var selectedVal=AJS.$("#customContentMarkup option:selected").val();
	  		console.log('setting current content markup: '+selectedVal);
	  		AJS.$("#contentToRenderMarkup").val(selectedVal);
	  	} else {
	  		AJS.$("#contentToRenderMarkup").val("velocity");//always
	  	}

	  	AJS.$("#contentToRenderType").val(showTypeAs);
	  	AJS.$("#contentToRender").val(editor.getSession().getValue());

		var postData=AJS.$('#jemhTemplatePreviewDataForm').serialize();
	  	console.log('posting template for rendering. post data: '+postData);

		var formUrl = AJS.$('#jemhTemplatePreviewDataForm').attr('action');
	  	console.log('post url: '+formUrl);

		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,
			dataType:"text",
			data:postData,
			timeout:60000
		}); //post

		console.log("waiting for completion");

	  	jqXHR.done(function(data, textStatus, errorThrown) {
	  		console.log("post returned");
	  		if (showTypeAs=='text') {
	  			//http://stackoverflow.com/questions/1219860/html-encoding-in-javascript-jquery
	  			data=('<pre>'+AJS.$("<div/>").text(data).html()+'</pre>');
	  		}
	  		if (editor==subjectEditor) {
	  			var oneline=data.replace(/(\r\n|\n|\r)/gm," ");
	  			console.log('setting subject: '+oneline);
	  			AJS.$(previewWrapperDivId).html(oneline);
	  		} else {
	  			console.log('setting non-subject content: '+data);
	  			AJS.$(previewWrapperDivId).html(data);
	  		}

	  	}).fail(function(xhr, data, textStatus, errorMessage) {
			console.log("RUN fail: textStatus="+textStatus+", errorMessage: "+errorMessage, xhr.status, xhr.responseText);
			const errorBody = serverResponseText(xhr, textStatus);
			console.log("errorBody: "+errorBody);
    	    AJS.messages.error("#adhoc-message-context", {
				   title:"Preview Failed",
				   body: errorBody,
				});

	  	});

	  	console.log("all done");
	}

	function showEditor(editWrapperDivId, previewWrapperDivId) {
		console.log("Showing editor");
	  	AJS.$(previewWrapperDivId).hide();
	  	AJS.$(editWrapperDivId).show();
	  	AJS.$(previewWrapperDivId).text("");
	  	AJS.$("#contentToRender").val("");
	}

	function saveConfig(formName) {
		var postData=AJS.$(formName).serialize();
		var formUrl = baseUrl+'/rest/jemh/latest/adhoc/save?sessionId='+adhocSessionId+'&issueKey='+encodeURI(issueKey);

		console.log('posting JEMH adhoc content by ajax');
		// post
		//contentType: sent to the server as a header
		//dataType is the response
		AJS.$.ajax({
			type: "POST",
			url: formUrl,
			dataType: "json",
			data: postData,
			timeout: 60000
		})
			.done(function () {
				AJS.messages.success("#adhoc-message-context", {
					title:"Success",
					body: '<p>Ad-hoc configuration has been saved</p>',
					fadeout: true
				});
			})
			.fail(function (data, textStatus, error) {
				AJS.messages.error("#adhoc-message-context", {
					title:"Failed to save Ad-hoc configuration",
					body: "Error: " + data.status
				});
			});
	}

	//post
	function sendJemhAdHocFormByAjax(dialog, formName) {
		var nextSessionId=generateUid();
		AJS.$("input[name='adhocNextSessionId']").val(nextSessionId);

		var postData=AJS.$(formName).serialize();
		var formUrl = AJS.$(formName).attr('action');

		console.log('posting JEMH adhoc content by ajax');
		// post
		//contentType: sent to the server as a header
		//dataType is the response
		var jqXHR=AJS.$.ajax({
			type:"POST",
			url:formUrl,
			dataType:"json",
			data:postData,
			timeout:60000
		});

		jqXHR.done(function(data, textStatus, errorThrown) {
			AJS.$(".jemh-adhoc-submit-button").removeAttr('disabled');
			var msg;
			if(!data) {
				if (errorThrown) {
					msg='adhoc-send Error: '+errorThrown;
				} else {
					msg='adhoc-send Unknown Error';
				}

				AJS.messages.error("#adhoc-message-context", {
					   title:"Notification not sent",
					   body: '<p>'+msg+'</p>'
					});
			}
			else {
				if (!data.error) {
					adhocSessionId = nextSessionId;
					AJS.$("input[name='adhocSessionId']").val(adhocSessionId);
					if (!AJS.$("#jemh-send-another").prop("checked")) {
						shutdown();
						AJS.flag({
							type: "success",
							title: "Success",
							body: "<p>The message was successfully queued for delivery.</p>",
							close: "auto"
						})
					} else {
						AJS.messages.success("#adhoc-message-context", {
							   title:"Success",
							   body: '<p>The message was successfully queued for delivery. Please close, or edit recipients as needed to send again.</p>',
							   fadeout: true
						});
						AJS.$("#adhoc-message-context").scrollIntoView();
					}
					
					if(data.autoComment){
						window.location.reload();
					}
				} else {
					msg="AdHoc notification failed : "+data.error+".  Detail: "+data.detail;
					AJS.messages.error("#adhoc-message-context", {
						   title:"Failed to send message",
						   body: '<p>'+data.error+'</p>'+
						   	'<p>Check the following:'+
						   		'<ul>'+
						   			'<li>If static recipients were set, ensure their format matches <i>name@domain.com</i>, personal quoted "name" parts are not supported </li>'+
						   			'<li>If custom fields were expected to supply recipients, perhaps they were empty</li>'+
						   			'<li>If entities (eg Reporter) were expected to supply recipients, perhaps they are were empty</li>'+
								 	'<li>If illegal velocity content was attempted to be rendered. Ensure that your velocity template or script has no illegal content</li>'+
						   		'</ul>'+
						   	'</p>'
					});
					console.error('adhoc failure detail: '+data.detail);
				}
			}

		}).fail(function(xhr, data, textStatus, errorMessage) {
			AJS.$(".jemh-adhoc-submit-button").removeAttr('disabled');
			console.error("sendJemhAdHocFormByAjax("+data+") failed: "+textStatus+" : "+formUrl+", errorMessage: "+errorMessage + "status:" + xhr.status + " " + xhr.statusText);
			const errorBody = serverResponseText(xhr, textStatus);
			console.log("errorBody: " + errorBody);
			AJS.messages.error("#adhoc-message-context", {
				   title:"Unable to download template",
				   body: errorBody,
			});
		});
	}

    JIRA.bind(JIRA.Events.NEW_CONTENT_ADDED, function(e, context, reason) {
        if (reason === JIRA.CONTENT_ADDED_REASON.panelRefreshed || reason === JIRA.CONTENT_ADDED_REASON.filterPanelOpened || reason === JIRA.CONTENT_ADDED_REASON.pageLoad)
        {
	        AJS.$('.jemh-viewissue-adhoc-trigger').off('click').click(function(event) {
	        	handleJemhAdHocNotificationClick();
	        	return false;
	        });
    	}
    });

    function setupKissMode(kissMode){
		console.log('kissMode: '+kissMode);
		if (kissMode=="simple")
		{
			//console.log("simple: so hiding");
			AJS.$('.adhoc-ui-kiss-mode-advanced').hide();
		}
		else
		{
			//console.log("advanced: so showing");
			AJS.$('.adhoc-ui-kiss-mode-advanced').show();
		}
    }

	function updateVeloWikiHelpLinkVisibility() {
		if (AJS.$("#customContentMarkup option:selected").val()=='wiki') {
			AJS.$('.wikimarkup-help-link').show();
			AJS.$('.velocitymarkup-help-link').hide();
		} else if (AJS.$("#customContentMarkup option:selected").val()=='velocity') {
			AJS.$('.velocitymarkup-help-link').show();
			AJS.$('.wikimarkup-help-link').hide();
		} else if (AJS.$("#customContentMarkup option:selected").val()=='velowiki') {
			AJS.$('.velocitymarkup-help-link').show();
			AJS.$('.wikimarkup-help-link').show();
		}
	}

	function clearAutoUploadedSessionAtts() {
    	var deleteFileUrl=baseUrl+'/rest/jemh/latest/adhoc/attachment/clear/?sessionId='+adhocSessionId+'&issueKey='+encodeURI(issueKey) +'&atl_token=' + atl_token();
		AJS.$.ajax({
		    url: deleteFileUrl,
		    type: 'DELETE',
		    success: function(result) {
		    	console.log('JEMH Adhoc dynamically uploaded resources cleared');
		    },
		    error: function(result) {
	    	    AJS.messages.error("#adhoc-message-context", {
					   title:"Dynamically uploaded resources clear up failed",
					   body: '<p>The resource dynamnically uploaded through the editor previously could not be removed for some reason</p>',
					});
	    	}
		});
	}
	function deleteSession() {
    	var deleteFileUrl=baseUrl+'/rest/jemh/latest/adhoc/deletesession/?sessionId='+adhocSessionId+'&issueKey='+encodeURI(issueKey)+'&atl_token=' + atl_token();
		AJS.$.ajax({
		    url: deleteFileUrl,
		    type: 'DELETE',
		    success: function(result) {
		    	console.log('JEMH Adhoc session resources cleared');
		    },
		    error: function(result) {
	    	    AJS.messages.error("#adhoc-message-context", {
					   title:"Uploaded session resource clear up failed",
					   body: '<p>The resources dynamically uploaded through the editor previously could not be removed for some reason</p>',
					});
	    	}
		});
	}

	function loadAce(setupAdhocUIfn) {
		var aceUrl = baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ace.js";
		AJS.$.ajax({
			  url: aceUrl,
			  success: function( scriptAsText, textStatus ) {
				     console.log( "ace.js was downloaded from "+aceUrl+" dl Status: "+textStatus+", evaluating in local context" );
				     eval(scriptAsText);

				     //https://groups.google.com/forum/#!topic/ace-discuss/2tXbbF9MCMY
				     ace.config.set("basePath", baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace");

				     AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ext-spellcheck.js" )
				     .done(function( script, textStatus ) {
				        console.log( "ext-spellcheck.js script was downloaded: "+textStatus);
				     })
				     .fail(function( jqxhr, settings, exception ) {
				       console.error( "custom ext-spellcheck.js script could not be downloaded" );
				     });

				     AJS.$.getScript( baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace/ext-language_tools.js" )
				     .done(function( script, textStatus ) {
				        console.log( "ext-language_tools.js script was downloaded: "+textStatus);
				     })
				     .fail(function( jqxhr, settings, exception ) {
				       console.error( "custom ext-language_tools.js script could not be downloaded" );
				     });

				     loadAceEditorInit(setupAdhocUIfn);
				  },
			  error: function( jqxhr, settings, exception ) {
				    console.log( aceUrl+" could not be downloaded: "+exception );
		    	    AJS.messages.error("#adhoc-message-context", {
						   title:"ACE Editor could not be downloaded",
						   body: '<p>The server responded with '+htmlEncode(errorMessage)+'</p>',
						});
			  },
			  dataType: "text", //stops evaluation in global page scope
			  cache: true //cache for future loads
		});
	}

	function loadDataTableScript(){

		AJS.$('<link>')
		  .appendTo('head')
		  .attr({type : 'text/css', rel : 'stylesheet'})
		  .attr('href', baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-datatable-latest/datatables.css");

		const dataTableJsUrl = baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-datatable-latest/datatables.js";

		const dataTableAdditionalJsUrl = baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-datatable-latest/DataTables-1.11.3/js/";
		const dataTableAdditionalCssUrl = baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-datatable-latest/DataTables-1.11.3/css/";
		const dataTableImagesUrl = baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-datatable-latest/DataTables-1.11.3/images/";

		AJS.$.getScript(dataTableJsUrl)
			.done(function(script, textStatus){
				dataTableLoaded = true;
			})
			.fail(function (jqxhr, settings, exception) {
				console.error(dataTableJsUrl + " script could not be downloaded: " + exception);
				AJS.messages.error("#adhoc-message-context", {
					title: "DataTable script could not be downloaded",
					body: '<p>The server responded with ' + htmlEncode(errorMessage) + '</p>',
				});
			});
	}

	function loadAceEditorInit(setupAdhocUIfn) {
		 AJS.$('<link>')
		  .appendTo('head')
		  .attr({type : 'text/css', rel : 'stylesheet'})
		  .attr('href', baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace-editor.css");

		 console.log( "CSS loaded, now adhoc custom script" );
		 var aceEditorUrl = baseUrl+"/download/resources/com.javahollic.jira.jemh-ui:jemh-ace-editor-latest/ace-editor.js";

		 console.log('editor sessionID: '+adhocSessionId);

		 AJS.$.getScript( aceEditorUrl )
		  .done(function( script, textStatus ) {
		     console.log( "custom ace-editor.js script was downloaded: "+textStatus+", setting up adhoc UI");
		     setupAdhocUIfn();
		     aceLoaded=true;
		  })
		  .fail(function( jqxhr, settings, exception ) {
		    console.error( aceEditorUrl+" script could not be downloaded: "+exception );
    	    AJS.messages.error("#adhoc-message-context", {
				   title:"ACE Editor script could not be downloaded",
				   body: '<p>The server responded with '+htmlEncode(errorMessage)+'</p>',
				});
		 });
	}

    function handleJemhAdHocNotificationClick(targetIssue)
    {
    	if (jemhAdHocPopupActive===true)
    	{
    		console.error("already running adhoc function, please wait before trying again.");
    		return;
    	}

    	jemhAdHocPopupActive=true;

    	AJS.$('.jemh-viewissue-adhoc-trigger').attr('disabled','disabled');

		issueKey=AJS.Meta.get("issue-key");
		console.log('issueKey='+issueKey+", targetIssueKey="+targetIssue);
		if (""+targetIssue!="undefined")
		{
			console.log('using supplied target issue: '+targetIssue);
			issueKey=targetIssue;
		}
		else
		{
			console.log('using AJSMeta located issue: '+issueKey);
		}

		adhocSessionId=generateUid();

		if (aceLoaded===false) {
		  loadAce(function setupAdhocUIfn(){
			  setupAdhocUI(issueKey);
		  });
		} else {
			console.log('ACE already loaded on this page');
			setupAdhocUI(issueKey);
		}
		
		if (dataTableLoaded === false){
			loadDataTableScript();
		} else {
			console.log('DataTable is already loaded');
		}


	return false;
    }

    function showTinyMceEditor()
    {
			AJS.$('.advanced-editor-support').hide();

 			//show
			AJS.$("div[name='richtext-wrapper']").show(100).css('height','auto');

 			//hide
 			AJS.$("div[name='advanced-wrapper']").hide().css('height','0px');
    }

    function showContentEditor(edType)
    {
    	clearAutoUploadedSessionAtts(); //background, call to clear any resources previously uploaded via the tinymce editor
 		if (edType=="richtext")
 		{
 			if (tinymceSetup===false)
 			{
 				setupTinyMce();
 			}
 			else
			{
 				showTinyMceEditor();
			}
 			AJS.$('#contentEditor-deprecated').hide(100);
 		}
 		else if (edType=="advanced")
 		{
 			if (aceSetup===false)
 			{
 				setupAce();
 			}

 			if (aceSetup)
 			{
	 			AJS.$('.advanced-editor-support').show();

	 			//show
				AJS.$("div[name='advanced-wrapper']").show(100).css('height','auto');

	 			//hide
	 			AJS.$("div[name='richtext-wrapper']").hide().css('height','0px');

				AJS.$('#contentEditor-deprecated').show(100);
 			}
 			else
 			{
 				console.error('Unable to initialize TinyMce, please log a bug report via jemh-support@thepluginpeople.com');
 			}
 		}
    }

    function generateUid() {
	    var delim = "-";

	    function S4() {
	        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
	    }

	    var uid = (S4() + S4() + delim + S4() + delim + S4() + delim + S4() + delim + S4() + S4() + S4());
	    console.log('generateUid: '+uid);
	    jemhGlobalAdHocSessionId=uid;
	    return uid;
	}

    function initTinyMce()
    {
    	console.log('initTinyMce: session='+adhocSessionId);
    	AJS.$("input[name='adhocSessionId']").val(adhocSessionId);
    	tinyMceUploadUrl = AJS.contextPath()+'/rest/jemh/latest/adhoc/attachment/upload?issueKey='+issueKey+'&sessionId='+adhocSessionId+'&atl_token=' + AJS.$('#atl_token').val();
    	try
	    {
    		/*
[				[
	    		    { title: 'Test template 1', content: '<code>some java code</code>' },
	    		    { title: 'Test template 2', content: '<h3>this is html</h3><p>Test 2</p><pre>PRE FORMATTED</pre>' },
	    		    { title: 'Test template 3', content: 'just some straight text\nwith a newline' }
	    		  ]
    		 */
    		var filePickerCallback = function(cb, value, meta) {
    		    var input = document.createElement('input');
    		    input.setAttribute('type', 'file');
    		    input.setAttribute('accept', 'image/*');

    		    // Note: In modern browsers input[type="file"] is functional without
    		    // even adding it to the DOM, but that might not be the case in some older
    		    // or quirky browsers like IE, so you might want to add it to the DOM
    		    // just in case, and visually hide it. And do not forget do remove it
    		    // once you do not need it anymore.

    		    input.onchange = function() {
    		      var file = this.files[0];
    		      console.log('file.name = '+file.name);
    		      // Note: Now we need to register the blob in TinyMCEs image blob
    		      // registry. In the next release this part hopefully won't be
    		      // necessary, as we are looking to handle it internally.
    		      var id = 'blobid' + (new Date()).getTime();
    		      var blobCache = tinymce.activeEditor.editorUpload.blobCache;
    		      var blobInfo = blobCache.create(id, file);
    		      blobCache.add(blobInfo);

    		      // call the callback and populate the Title field with the file name
    		      cb(blobInfo.blobUri(), { title: file.name });
    		    };

    		    input.click();
    		  };

    		var scripletTemplateUrl = AJS.contextPath()+'/rest/jemh/latest/adhoc/scriptlets?atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content')+'&issueKey='+issueKey;
	    	tinyMceEditor = tinymce.init({
	    		selector: 'textarea#tinymce-template-content',
	    		theme: 'modern',
				branding: false,
	    		height: '500',
	    		menubar: true,
	    		plugins: [
	    			'advlist autolink lists link image charmap preview hr anchor ',
	    		    'searchreplace wordcount visualblocks visualchars code fullscreen',
	    		    'insertdatetime nonbreaking table contextmenu directionality',
	    		    'template paste textcolor colorpicker imagetools codesample'
	    		  ],
	    		toolbar: 'preview | undo redo | styleselect | bold italic underline | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | forecolor backcolor emoticons | link image | codesample',
	    		templates: scripletTemplateUrl,
	    		file_browser_callback_types: 'file image',
				browser_spellcheck: true,
	    		image_title: true,
	    		paste_data_images: true,
	    		automatic_uploads: true,
	    		// URL of our upload handler (for more details check: https://www.tinymce.com/docs/configure/file-image-upload/#images_upload_url)
				images_upload_handler: handleTinyMCEImageUpload,
				file_picker_types: 'image',
	    		file_picker_callback: filePickerCallback,
	    		relative_urls: false,
	    		remove_script_host : false,
	    		setup: function (editor) {
                    editor.on('change', function(e) {
                        updateAttachmentSizes();
                    });
                }
	    	});
	    	tinymceSetup=true;
            console.log("TinyMCE " + tinymce.majorVersion + "." + tinymce.minorVersion + " ready to serve!");

	    	showTinyMceEditor();

	    	if ( AJS.$("#jemh-templateset-selection option:selected").val() > 0)
			{
				console.log('TinyMCE auto loading rendered TemplateSet for editing');
				loadRenderedContentforRicheTextEditor(AJS.$("#jemh-templateset-selection option:selected").val(),subjectEditor);
			}
	    	else
	    	{
	    		console.log('TinyMCE loading custom default');

	    		var defaultCustomSubject=AJS.$('#defaultCustomSubject').val();
				subjectEditor.getSession().setValue(defaultCustomSubject);

	    		var defaultCustomContent=AJS.$('#defaultCustomContent').val();
				setEditorContent(defaultCustomContent);
	    	}

	    }
	    catch (e) {
	    	console.error('TinyMCE init failure: '+e);
    	    AJS.messages.error("#adhoc-message-context", {
				   title:"Unable to initialize RichText editor",
				   body: '<p>Unable to initialize RichText editor, please log a bug report via jemh-support@thepluginpeople.com</p>',
            });
	    }
    }

	function handleTinyMCEImageUpload(blobInfo, success, failure){
		/*
			this method is responsible for handling image upload through the TinyMC Editor, please see:
			https://www.tiny.cloud/docs-4x/general-configuration-guide/upload-images/

			Params:
			1. blobInfo: contains the image information needed for the attachment upload restService
			2. success: A method that the json 'location' property should be passed to to complete the image upload
			3. failure: Pass any error messages to this method if the upload fails

			Note: When/if TinyMCE is updated to v5 this handler will also take a forth 'progress' parameter. a number between 1 and 100 should be passed to indicate the upload progress
		 */
		let finalFilename;
		let rawFilename = blobInfo.filename();
		let splitFilename = rawFilename.split(".");
		if(splitFilename.length > -1){
			finalFilename = splitFilename[0] + "_" + blobInfo.blob().size + "." + splitFilename[1];
		}else{
			finalFilename = splitFilename[0] + "_" + blobInfo.blob().size;
		}
		let formData = new FormData();
		formData.append('file', blobInfo.blob(), finalFilename);
		let tinyMceUploadUrl = AJS.contextPath()+'/rest/jemh/latest/adhoc/attachment/upload?issueKey='+issueKey+'&sessionId='+adhocSessionId+'&overrideAttachment=true'+'&atl_token=' + AJS.$('#atl_token').val();
		let jqXHR= AJS.$.ajax({
			url: tinyMceUploadUrl,
			type: "POST",
			cache: false,
			contentType:false,
			processData: false,
			data: formData
		});

		jqXHR.done(function(data) {
			if(data.location){
				success(data.location);
			}else{
				failure(data)
			}
		}).fail(function(data) {
			failure(data);
		});
	}

	function applyAddCommentFieldVisibility(){
		if (AJS.$('#addContentAsComment').prop("checked")) {
			AJS.$('#addContentAsCommentFields').show('fast');
		} else {
			AJS.$('#addContentAsCommentFields').hide('fast');
		}
	}

    function loadRenderedContentforRicheTextEditor(templateSetId, subjectEditor)
    {
		var templateSetUrl=baseUrl+'/rest/jemh/latest/adhoc/renderHtmlTemplate?atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content')+'&issueKey='+issueKey+'&templateId='+templateSetId+'&sessionId='+adhocSessionId;
		var jqXHR=AJS.$.get(templateSetUrl);
		jqXHR.done(function(data, textStatus, errorMessage) {
			if(data.errors) {
	    	    AJS.messages.error("#adhoc-message-context", {
                   title:"Unable to render template",
                   body: '<p>The server responded with '+htmlEncode(errorMessage)+'</p>',
                });
			} else {
				//console.log('got template: \n'+data);
				setEditorContent(data.html);

				if (data.subject != null) {
					subjectEditor.getSession().setValue(data.subject);
				}
			}
		});
    }

	//When updating tinymce use the build customizer [https://www.tiny.cloud/get-tiny/custom-builds/] and include plugins defined in the tinymce configuration in adhoc.js initTinyMce()
    function setupTinyMce() {
        AJS.$.getScript(baseUrl + "/download/resources/com.javahollic.jira.jemh-ui:jemh-tinymce-editor-latest/tinymce/tinymce.min.js")
            .done(function () {
                addCssResource(baseUrl + "/download/resources/com.javahollic.jira.jemh-ui:jemh-tinymce-editor-latest/tinymce/skins/lightgray/skin.min.css");
                addCssResource(baseUrl + "/download/resources/com.javahollic.jira.jemh-ui:jemh-tinymce-editor-latest/tinymce/skins/lightgray/content.min.css");
                addCssResource(baseUrl + "/download/resources/com.javahollic.jira.jemh-ui:jemh-tinymce-editor-latest/tinymce/plugins/codesample/css/prism.css");
                initTinyMce();
            })
            .fail(function (jqxhr, settings, exception) {
                console.error("TinyMCE script download failed: " + exception);
                AJS.messages.error("#adhoc-message-context", {
                    title: "Unable to download the TinyMCE script",
                    body: '<p>Please review JIRA baseurl configuration, then log a bug report via jemh-support@thepluginpeople.com</p>',
                });
            });
    }

    function addCssResource(url) {
        AJS.$("<link>").attr({ rel: "stylesheet", type: "text/css", href: url }).appendTo("head");
    }

    function setupAce() {
    	console.log('setupAce: session='+adhocSessionId);
    	AJS.$("input[name='adhocSessionId']").val(adhocSessionId);

    	contentEditor=buildAceEditor('adHocSubmitForm', 'content-editor', 'content-statusBar', 'content', 'velocity');
	 	contentEditor.setOption("spellcheck", true);
	 	aceSetup=true;
		AJS.$("#content-preview-wrapper").hide();
		AJS.$("#content-preview_link").click(function(e) {
		  	  e.preventDefault();
			  if (AJS.$("#content-preview-wrapper").is(":hidden"))
			  {
			  	showPreview(contentEditor, "#content-edit-wrapper", "#content-preview-wrapper", AJS.$("#contentType option:selected").val());
			  }
			  else
			  {
			  	showEditor("#content-edit-wrapper", "#content-preview-wrapper");
			  }
		      return false;
		}); //click
    }

    function setEditorContent(custContent)
    {
    	var contentEditorType=AJS.$("#contentEditor").val();
		if (contentEditorType=="advanced")
		{
			//console.log("setting advanced editor with: \n"+custContent);
			contentEditor.getSession().setValue(custContent);
		}
		else if (contentEditorType=="richtext")
		{
			//console.log("setting richtext editor with: \n"+custContent);
			tinyMCE.activeEditor.setContent(custContent, {format : 'raw'});
		}
    }

    //destroy
    function shutdown()
    {
		dialog.hide();
		AJS.$("#jemh-adhoc-notification-dialog").remove();
		jemhAdHocPopupActive=false;

		//clear server atts
		try
		{
			deleteSession();
		}
		catch (e)
		{
			console.error('unable to deleteSession resources, background jobs will do this later: '+e);
		}

		//clear subject
		try
		{
			subjectEditor.destroy();
			AJS.$('subject-editor').remove();
		}
		catch (e)
		{
			console.error('unable to destroy ace subject-editor: '+e);
		}

		//clear content
		if (aceSetup)
		{
			try
			{
			    contentEditor.destroy();
			    AJS.$('contentEditor-editor').remove();
			}
			catch (e)
			{
				console.error('unable to destroy ace content-editor: '+e);
			}
			finally
			{
				aceSetup=false;
			}
		}

	    if (tinymceSetup)
	    {
	    	console.log('clearing tinymce references for active editor : '+tinyMCE.activeEditor);
	    	try
	    	{
	    	console.log(tinyMCE.activeEditor);
	    		console.log(AJS.$('#tinymce-template-content'));
	    		AJS.$('#tinymce-template-content').remove();
                tinyMCE.activeEditor.remove();
	    	}
	    	catch (e)
	    	{
	    		console.error('unable to destroy tinymce: '+e);
	    	}
	    	finally
	    	{
	    		tinymceSetup=false;
	    	}
	    }

		AJS.$('.jemh-viewissue-adhoc-trigger').removeAttr('disabled');

    }

    function isValidToSend() {
    	console.log('validating form to send');

    	var toLen=AJS.$("#to").val().length;
    	var ccLen=AJS.$("#cc").val().length;
    	var bccLen=AJS.$("#bcc").val().length;

    	console.log('toLen='+toLen+', ccLen='+ccLen+', bccLen='+bccLen);

    	var toCfSet=AJS.$("#customFieldForTo option:selected").length>0;
    	var ccCfSet=AJS.$("#customFieldForCc option:selected").length>0;
    	var bccCfSet=AJS.$("#customFieldForBcc option:selected").length>0;

    	console.log('toCfSet='+toCfSet+', ccCfSet='+ccCfSet+', bccCfSet='+bccCfSet);

    	var toEntitiesSet=AJS.$("#entitiesForTo option:selected").length>0;
    	var ccEntitiesSet=AJS.$("#entitiesForCc option:selected").length>0;
    	var bccEntitiesSet=AJS.$("#entitiesForBcc option:selected").length>0;

    	console.log('toEntitiesSet='+toEntitiesSet+', ccEntitiesSet='+ccEntitiesSet+', bccEntitiesSet='+bccEntitiesSet);

    	var toValid = toLen!==0 || toCfSet || toEntitiesSet;
    	var ccValid = ccLen!==0 || ccCfSet || ccEntitiesSet;
    	var bccValid = bccLen!==0 || bccCfSet || bccEntitiesSet;

    	console.log('toValid='+toValid+', ccValid='+ccValid+', bccValid='+bccValid);
    	
    	var toEntitiesSet=AJS.$("#entitiesForTo option:selected").length>0;
    	
    	return (toValid || ccValid || bccValid);
    }

    function getReadableFileSizeString(fileSizeInBytes) {

        var i = -1;
        var byteUnits = [' kB', ' MB', ' GB'];
        do {
            fileSizeInBytes = fileSizeInBytes / 1024;
            i++;
        } while (fileSizeInBytes > 1024);

        return Math.max(fileSizeInBytes, 0.1).toFixed(1) + byteUnits[i];
    }

	function checkAttachmentsForDuplicate(filename){

		var duplicateFound = false;
		for(let i =0; i <= oneup; i ++){
			let attachmentRow = AJS.$('#adhoc_delete_file_'+i).attr('data');

			if(attachmentRow !== null)
			{
				//we decode the row because the filename is encoded before being added to the element
				let decodedRow = decodeURI(attachmentRow);
				if(decodedRow === filename){
					duplicateFound = true;
					break;
				}
			}
		}

		return duplicateFound;
	}

    function sendFileToServer(filename, size, formData, override)
    {
		console.log('sendFileToServer()');
		var uploadURL = AJS.contextPath()+'/rest/jemh/latest/adhoc/attachment/upload?issueKey='+issueKey+'&sessionId='+adhocSessionId+'&manualUpload=true&overrideAttachment='+override+'&encodedFilename='+encodeURI(filename)+ '&atl_token=' + AJS.$('#atl_token').val();

		var bar = $('.ul_progressbar');
		var percent = $('.ul_percent');
		var status = $('.ul_status');

		var percentVal = '0%';
		bar.width(percentVal);
		percent.html(percentVal);
		status.html('Uploading...');

		var jqXHR = AJS.$.ajax({
			xhr: function() {
				var xhrobj = AJS.$.ajaxSettings.xhr();

				xhrobj.upload.addEventListener("progress", function(evt) {
					if (evt.lengthComputable) {
						var percentComplete = evt.loaded / evt.total;
						percentComplete = parseInt(percentComplete * 100);
						console.log(percentComplete);
						var percentVal = percentComplete + '%';
						bar.width(percentVal);
						percent.html(percentVal);
					}
				}, false);

				return xhrobj;
			},
			url: uploadURL,
			type: "POST",
			cache: false,
			contentType:false,
			processData: false,
			data: formData
		});

		jqXHR.done(function(data, textStatus, errorThrown) {
			console.log("attachment upload completed:"+ textStatus);
			status.empty();
			percent.empty();

			if(data.isAttachmentOverwritten){
				//if the uploaded attachment replaces an existing file, the related table row needs to be replaced as well
				let rowID = AJS.$("a[data='"+encodeURIComponent(data.filename)+"']").attr('id');
				//remove existing row
				AJS.$('#row_'+rowID).remove();

				AJS.messages.success("#adhoc-message-context", {
					title:"File updated",
					body: '<p>The file <strong>'+data.filename+'</strong> has been overwriten</p>',
					fadeout: true
				});
			}else if(data.isAttachmentRenamed){
				AJS.messages.success("#adhoc-message-context", {
					title:"File updated",
					body: '<p>The file <strong>'+data.filename+'</strong> has been renamed to <strong>'+data.filename+'</strong></p>',
					fadeout: true
				});
			}
			var deleteId='adhoc_delete_file_'+(++oneup);
			AJS.$('#jemh-adhoc-manual-filelist-table > tbody:last').after('<tr data-size='+size+' id="row_'+deleteId+'"><td><pre>'+data.filename+'</pre></td><td>'+getReadableFileSizeString(size)+'</td><td><A id="'+deleteId+'" data="'+encodeURIComponent(data.filename)+'" ><span title="Delete" class="aui-icon aui-icon-small aui-iconfont-remove"></span></a></td></tr>').show(500);

			console.log("Attachment added, recalculating attachments");
			updateAttachmentSizes();

			AJS.$('#'+deleteId).click(function() {
				var data=AJS.$(this).attr('data');
				console.log('found filename in data attrib: '+data);

				var deleteFileUrl=baseUrl+'/rest/jemh/latest/adhoc/attachment/deleteone/?sessionId='+adhocSessionId+'&issueKey='+encodeURI(issueKey)+'&filename='+encodeURI(data) + '&atl_token=' + AJS.$('#atl_token').val();
				console.log("delete resource url: "+deleteFileUrl);
				AJS.$.ajax({
					url: deleteFileUrl,
					type: 'DELETE',
					success: function(result) {
						console.log("Attachment removed, recalculating attachments");

						AJS.$('#row_'+deleteId).remove();
						setInterval(updateAttachmentSizes(),50);
						AJS.messages.success("#adhoc-message-context", {
							title:"File deleted",
							body: '<p>The file <strong>'+decodeURIComponent(data)+'</strong> has been removed</p>',
							fadeout: true
						});
					},
					error: function(result) {
						AJS.messages.error("#adhoc-message-context", {
							title:"File delete failed",
							body: '<p>The file ['+decodeURIComponent(data)+'] could not be removed for some reason</p>',
						});
					}
				});
			});
		}).fail(function(data, textStatus, errorMessage) {
			AJS.messages.error("#adhoc-message-context", {
				title: "Upload failure",
				body: "The upload did not complete, perhaps it was too large? Message given: "+errorMessage,
			});
		});
    }

	// ===============================================================================
	
	function updateAttachmentSizes()
	{
		console.log('Calculating ATT SIZE');
		
		var totalAttSize=0;
		var issueAttachment=0;
		var staticResourcesAttachment=0;
		var uploadedAttachments=0;

		console.log('1. filesizes for jira issue attachments:');
		AJS.$("#issueAttachments option:selected").each(function(index, item){
			var attSize=Number(AJS.$(this).attr('data-size'));
			console.log('found jira issue atts with size: '+attSize);
			totalAttSize+=attSize;
			issueAttachment+=attSize;
		});
		
		console.log('2. filesizes for static attachments:');
		AJS.$("#jemh-adhoc-staticresources option:selected").each(function(index, item){
			var attSize=Number(AJS.$(this).attr('data-size'));
			console.log('found static atts with size: '+attSize);
			totalAttSize=totalAttSize+=attSize;
			staticResourcesAttachment+=attSize;
		});
		
		console.log('3. filesizes for darg/drop manually added files:');
		AJS.$("#jemh-adhoc-manual-filelist-table tr").each(function(index, item) {
			if (AJS.$(this).attr('data-size')) {
				var attSize=Number(AJS.$(this).attr('data-size'));
				console.log('found manually uploaded att with size: '+attSize);
				totalAttSize+=attSize;
				uploadedAttachments+=attSize;
			}
		});
		console.log("CommentByteSize: "+getCommentByteSize()+"\n"+"TotalAttSize: "+totalAttSize)
		totalAttSize+=getCommentByteSize();
		
		AJS.$('#attTotalSize').text(totalAttSize+' bytes ('+(totalAttSize/1024/1024).toFixed(2)+' MB)');
		updateAttachmentSizeBar(totalAttSize);
	}

	function getCommentByteSize()
    {
        var contentEditorType=AJS.$("#contentEditor").val();
        var size;
        if (contentEditorType=="advanced")
        {
            var comment=contentEditor.getSession().getValue();
            size = encodeURI(comment).split(/%(?:u[0-9A-F]{2})?[0-9A-F]{2}|./).length - 1;
        }
        else if (contentEditorType=="richtext")
        {
            tinyMCE.activeEditor.uploadImages();
            var comment =tinyMCE.activeEditor.getContent();
            size = encodeURI(comment).split(/%(?:u[0-9A-F]{2})?[0-9A-F]{2}|./).length - 1;
        }
        return size;
    }

	function updateAttachmentSizeBar(currentMailSizeInByte)
	{
	    AJS.$(".button-panel-button").attr('id', 'dialogbtn');
	    var totalAttachSize = (AJS.$(this).attr('attAllowedSize') ? Number(AJS.$(this).attr('attAllowedSize').innerHTML) : 0);
	    var percentage = 0;
        if(totalAttachSize !== 0)
        {
            var availableAttachSizeInByte = totalAttachSize*1024*1024;
            percentage = ((currentMailSizeInByte/availableAttachSizeInByte)*100).toFixed(2);
            console.log("Percentage calculation: "+percentage);
            var indicatorBar = document.getElementsByClassName("aui-progress-indicator-value")[0];
            if(percentage >= 90)
            {
                indicatorBar.style.width=percentage+'%';
                indicatorBar.style.backgroundColor = "#DE350B"
                if(percentage >=100)
                {
                    AJS.$("#dialogbtn").prop('disabled', true);
                    AJS.$("#dialogbtn").addClass('aui-button');
                    AJS.$("#dialogbtn").removeClass('button-panel-button');
                    AJS.$("#dialogbtn").css("margin-right","10px");

					AJS.$(".jemh-adhoc-submit-button").attr('disabled', 'disabled');

                    var exceededLimitBy = calculateByteLimitExceededBy(currentMailSizeInByte, totalAttachSize);

                    AJS.messages.error("#adhoc-message-context", {
                       title:"Email limit exceeded by: "+exceededLimitBy,
                       body: '<p>You\'ve exceeded the allocated limit of the email<br><br><b>Resolution</b><br>- <b>Remove</b> attachments to reduce the size of the email<br>- <b>Reduce</b> the character count in your comment<br>- Ask the <b>Administrator</b> to increase the email limit',
                    });
                }
            }
            else
            {
                if(percentage >= 60)
                {
                    indicatorBar.style.backgroundColor = "#FF991F";
                }
                else
                {
                    indicatorBar.style.backgroundColor = "#00875A";
                }
                indicatorBar.style.width=percentage+'%';

                AJS.$("#dialogbtn").prop('disabled', false);
                AJS.$("#dialogbtn").addClass('button-panel-button');
                AJS.$("#dialogbtn").removeClass('aui-button');
                AJS.$("#dialogbtn").css("margin-right","10px");

				AJS.$(".jemh-adhoc-submit-button").removeAttr('disabled');
            }
        }
	}

	function calculateByteLimitExceededBy(currentByteSize, availableSizeInMb)
	{
	    var availableSizeInBytes = (availableSizeInMb*1024*1024).toFixed(2);
	    var exceededLimitByInBytes = currentByteSize - availableSizeInBytes;
	    var returnCalculationInString;

	    if(exceededLimitByInBytes < 100000)
	    {
	        //Less than 0.1 MB
	        returnCalculationInString = exceededLimitByInBytes+" bytes";
	    }
	    else
	    {
	        returnCalculationInString = (exceededLimitByInBytes/1024/1024).toFixed(2)+" MB";
	    }
	    return returnCalculationInString;

	}
	
	function handleFileUpload(files,dragdrop) {
		let uploadDialogActive = false;
		let renameText = AJS.I18n.getText('jemh.adhoc.attachment.dialog.rename');
		let overwriteText = AJS.I18n.getText('jemh.adhoc.attachment.dialog.overwrite');

		for (var i = 0; i < files.length; i++) {
			let filename = files[i].name;

			if(checkAttachmentsForDuplicate(filename)){

				if(!uploadDialogActive) {
					uploadDialogActive = true;
					AJS.dialog2('#upload-dialog').show();

					//if the close button is used, exit the dialog and remove listeners
					AJS.$('#upload-dialog-cancel').click(function () {
						AJS.dialog2('#upload-dialog').hide();
						AJS.$('#upload-dialog').off();
						AJS.$('#upload-dialog').children().off();
						AJS.$('#upload-dialog-content-filelist-table > tbody').find("tr").remove();
					});

					//add a listener for the change in the dialog table. If it is empty then the dialog can be closed

					AJS.$('#upload-dialog-submit').click(function (){
						AJS.$('#upload-dialog-content-filelist-table > tbody').find("tr").each(function (){
							let fileId = AJS.$(this).attr('data');

							let overwrite = AJS.$('#upload-dialog-overwrite-adhoc_upload_file_'+fileId).prop('checked');
							let filename = files[fileId].name;
							let fileSize = files[fileId].size;
							var fd = new FormData();
							fd.append('file', files[fileId]);
							sendFileToServer(filename, fileSize, fd, overwrite);
						})

						AJS.$('#upload-dialog-cancel').click();
					});
				}

				//create a table row item for the duplicate attachment
				let uploadId='adhoc_upload_file_'+i;

				AJS.$('#upload-dialog-content-filelist-table > tbody:last').append('<tr id="upload_row_'+uploadId+'" data="'+i+'">' +
					'<td><pre>'+filename+'</pre></td>' +
					'<td><fieldset class="group">' +
					'<label class="radio-inline" for="upload-dialog-rename-'+uploadId+'">'+encodeURI(renameText)+
					'<input class="radio short-field" type="radio" id="upload-dialog-rename-'+uploadId+'" name="upload-dialog-option-'+uploadId+'" data="'+uploadId+' value="rename"">' +
					'</label>' +
					'<label class="radio-inline" for ="upload-dialog-overwrite-'+uploadId+'">'+encodeURI(overwriteText)+
					'<input class="radio short-field" type="radio" id="upload-dialog-overwrite-'+uploadId+'" data="'+uploadId+'" name="upload-dialog-option-'+uploadId+'" value="overwrite"checked="checked">' +
					'</label></fieldset></td>' +
					'<td><A id="remove_upload_'+uploadId+'" data="'+uploadId+'" ><span title="Remove" class="aui-icon aui-icon-small aui-iconfont-remove"></span></a></td></tr>').show(500);

				AJS.$('#remove_upload_'+uploadId).click(function() {
					let data=AJS.$(this).attr('data');
					AJS.$('#upload_row_'+data).children().off();
					AJS.$('#upload_row_'+data).remove();
				});

			}else{
				let filename = files[i].name;
				let fileSize = files[i].size;
				var fd = new FormData();
				fd.append('file', files[i]);
				sendFileToServer(filename, fileSize, fd, true);
			}
		}
	}

    function setupDragAndDrop() {
		var dragdrop = AJS.$('#jemh-adhoc-dragdrop-attachment-zone');
		dragdrop.on('dragenter', function (e) {
		    e.stopPropagation();
		    e.preventDefault();
		    AJS.$(this).css('border', '2px dashed #f79232');
		});
		dragdrop.on('dragleave', function (e) {
		    AJS.$(this).css('border', '2px dashed #cccccc');
		});
		dragdrop.on('dragover', function (e) {
		     e.stopPropagation();
		     e.preventDefault();
		});
		dragdrop.on('drop', function (e) {
		     AJS.$(this).css('border', '2px dashed #cccccc');
		     e.preventDefault();
		     var files = e.originalEvent.dataTransfer.files;

		     //We need to send dropped files to Server
		     handleFileUpload(files,dragdrop);
		});
    }
    
    function humanFileSize(bytes, si) {
        var thresh = si ? 1000 : 1024;
        if(Math.abs(bytes) < thresh) {
            return bytes + ' B';
        }
        var units = si
            ? ['kB','MB','GB','TB','PB','EB','ZB','YB']
            : ['KiB','MiB','GiB','TiB','PiB','EiB','ZiB','YiB'];
        var u = -1;
        do {
            bytes /= thresh;
            ++u;
        } while(Math.abs(bytes) >= thresh && u < units.length - 1);
        return bytes.toFixed(1)+' '+units[u];
    }

    function formatSelect2Items(state) {
    	var originalOption = state.element;
    	var createDate = new Date(AJS.$(originalOption).data("created"));
    	return (state.text + "<span style='float:right'>" + humanFileSize(AJS.$(originalOption).data("size"),true)+", created " + createDate);
    }

    function sortS2Results(results, container, query) {
    	return results.sort(function(a, b) {
    		var aSize = AJS.$(a.element[0]).data("created");
    	    var bSize = AJS.$(b.element[0]).data("created");
    	    if (aSize > bSize) {
    	      return -1;
    	    } else if (aSize < bSize) {
    	      return 1;
    	    } else {
    	      return 0;
    	    }
    	});
    }

    function setCustomContent(){

		let subjectTextarea = AJS.$('textarea[name="subject"]');
		let updatedValue;
		if(subjectTextarea) {
			updatedValue=subjectEditor.getSession().getValue();
			subjectTextarea.val(updatedValue);
		}
		else {
			console.error('subject textarea not found by name');
		}

		let contentTextarea;
		let contentEditorType=AJS.$("#contentEditor").val();
		if (contentEditorType==="advanced") {
			updatedValue=contentEditor.getSession().getValue();
			contentTextarea = AJS.$('textarea[name="content"]');
			contentTextarea.val(updatedValue);
		}
		else if (contentEditorType==="richtext") {
			tinyMCE.activeEditor.uploadImages();

			updatedValue =tinyMCE.activeEditor.getContent();
			contentTextarea = AJS.$('textarea[name="tinymce-content"]');
			contentTextarea.val(updatedValue);
		}
	}

    function setupAdhocUI(issueKey) {
    	console.log( "setupAdhocUI()");
    		var dlgHeight=AJS.$(window).height()-60;

		AJS.$.get(baseUrl+"/pluginpeople/jemh/JEMHAdHocPopup!edit.jspa?issueKey="+issueKey, function(response) {
			dialog = new AJS.Dialog({
			    width: 1024,
			    height: dlgHeight,
			    id: "jemh-adhoc-notification-dialog",
			    closeOnOutsideClick: false
			});

	        dialog.addHeader("JEMH Ad-Hoc Notification");
	        dialog.addPanel('Details', response, 'x');
			let send = AJS.I18n.getText('jemh.adhoc.templates.send')
			let cancel = AJS.I18n.getText('jemh.adhoc.templates.cancel')
			dialog.addButton(send, function (dialog) { }, 'jemh-adhoc-submit-button jemh-adhoc-buttons');
	        dialog.addLink(cancel, function (dialog) { shutdown();}, 'jemh-adhoc-cancel-button');

	        //add checkbox for send another feature
			let sendAnother = AJS.I18n.getText('jemh.adhoc.templates.send.another');
	        var sendAnotherHtml = "<input type='checkbox' id='jemh-send-another'><label style='margin-right:10px' for='jemh-send-another'>"+sendAnother+"</label>";
	        AJS.$("#jemh-adhoc-notification-dialog .dialog-button-panel").prepend(sendAnotherHtml);

	        AJS.tabs.setup();
	        AJS.$("#issueAttachments").auiSelect2({
	        	placeholder: "Select file(s)",
	        	formatResult: formatSelect2Items,
	        	sortResults: sortS2Results,
	        	formatNoMatches: function(term) {return "No matching issue attachments found"}
	        });
	        AJS.$("#jemh-adhoc-staticresources").auiSelect2({placeholder: "Select file(s)", formatNoMatches: function(term) {return "No matching static resources found"}});

			subjectEditor=buildAceEditor('adHocSubmitForm', 'subject-editor', 'subject-statusBar', 'subject', 'velocity');
			subjectEditor.setOption("spellcheck", true);
			AJS.$("#subject-preview-wrapper").hide();
			AJS.$("#subject-preview_link").click(function(e) {
			  	e.preventDefault();
				if (AJS.$("#subject-preview-wrapper").is(":hidden"))
				{
				  	showPreview(subjectEditor, "#subject-edit-wrapper", "#subject-preview-wrapper", "text");
				}
				else
				{
				  	showEditor("#subject-edit-wrapper", "#subject-preview-wrapper");
				}
			  	return false;
			}); //click

			var contentEditorType = AJS.$("#defaultContentEditor").val();
		 	//console.log('setting up ContentEditorType: '+contentEditorType);

		 	AJS.$("#contentEditor").change(function(event) {
		 		var edType=AJS.$(this).val();
		 		console.log("selected "+edType+" contentEditorType");
		 		showContentEditor(edType);
		 	});

			AJS.$("#jemh-adhoc-save").click(function (event) {
				AJS.$("#adhoc-message-context").empty();
				let currentSelectedValue=AJS.$("#jemh-templateset-selection option:selected").val();
				if (currentSelectedValue == '0') {
					setCustomContent();
				}
				saveConfig("#adHocSubmitForm");
				event.preventDefault();
			});

			AJS.$("select#rememberMe").change(function (event) {
				if (this.value) {
					AJS.$("#jemh-adhoc-save").prop('disabled', false);
				} else {
					AJS.$("#jemh-adhoc-save").prop('disabled', true);
				}
			});
			
		 	//onSubmit
			AJS.$(".jemh-adhoc-submit-button").click(function(e) {
				e.preventDefault();
				AJS.$("#adhoc-message-context").empty();
				AJS.$(".jemh-adhoc-submit-button").attr('disabled', 'disabled');

				if (isValidToSend())
				{
					setCustomContent();
                    debounce(sendJemhAdHocFormByAjax(dialog, "#adHocSubmitForm"), 250, false);
				}
				else
				{
					AJS.messages.error("#adhoc-message-context", {
						   title:"No Recipients have been set",
						   body: '<p>Mail cannot be sent without at least one static Recipient, Custom Field or Entity (e.g. reporter) selected for any of To/Cc/Bcc.</p>'
						});
				}
				lastClick=0;
				return false;
			});

			var tsData;

			//
			// TemplateSet selection
			//
			AJS.$('#jemh-templateset-selection').change(function(ev) {

				var contentEditorType = AJS.$("#contentEditor").val();
				if (contentEditorType=="advanced")
				{
					showEditor("#content-edit-wrapper", "#content-preview-wrapper"); //reset editor before updating

					var currentSelectedValue=AJS.$("#jemh-templateset-selection option:selected").val();
					if (currentSelectedValue == '0') {
						setupCssStyle(0); // default

						console.log('loading customContent');
						var custMarkup=AJS.$('#defaultCustomMarkup').val();
						AJS.$('#customContentMarkup').val( custMarkup );
						AJS.$("#customContentMarkup").prop('disabled', false);

						var custSubject=AJS.$('#defaultCustomSubject').val();
						//console.log('custom subject is: '+custSubject);
						subjectEditor.getSession().setValue(custSubject);

						var custContent=AJS.$('#defaultCustomContent').val();
						//console.log('custom content is: '+custContent);
						setEditorContent(custContent);

						//show the custom content markup type
						//console.log('showing custom content editor: ');
						AJS.$('.adhoc-ui-custom-content-markup').show();

					} else {
						var contentType=AJS.$('#contentType').val();
						AJS.$('.adhoc-ui-custom-content-markup').hide();
						var custMarkup=AJS.$('#defaultCustomMarkup').val();
						AJS.$('#customContentMarkup').val( 'velocity' );
						AJS.$("#customContentMarkup").prop('disabled', true);

						console.log('loading templateSet '+currentSelectedValue);
						var templateSetUrl=AJS.contextPath()+'/rest/jemh/latest/adhoc/download/'+currentSelectedValue+'?atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content')+'&issueKey='+issueKey;
						var jqXHR=AJS.$.getJSON(templateSetUrl, {
								format: "json"
						});

						jqXHR.done(function(data, textStatus, errorMessage) {
							if(data.errors)
							{
								console.log('getTemplateSet() '+currentSelectedValue+', errors');
							}
							else
							{
								tsData=data;
								console.log('setting TemplateSet subject: '+data.subject);
								setupCssStyle(data.cssStyleSource);

								if (data.subject) {
									subjectEditor.getSession().setValue(data.subject);
								}

								showEditor("#subject-edit-wrapper", "#subject-preview-wrapper");

								//console.log('setting content with: '+contentType);
								if (contentType=='text') {
									//console.log('setting text content with: '+data.text);
									setEditorContent(data.text);
								} else {
									//console.log('setting content with: '+data.html);
									setEditorContent(data.html);
								}

								//console.log('showing templateset content editor: ');
								showEditor("#content-edit-wrapper", "#content-preview-wrapper");
							}
						});
					}
				}
				else if (contentEditorType=="richtext")
				{
					//clear images and attachments previously stored during this edit session
					console.log('deleting prior images and attachments stored in this session, adhocSessionId:', adhocSessionId);
					var templateSetUrl=AJS.contextPath()+'/rest/jemh/latest/templateset/clearsession?issueKey='+issueKey+'&sessionId='+adhocSessionId+'&atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content');
					AJS.$.ajax({
					    url: templateSetUrl,
					    type: 'DELETE',
					    success: function(result) {
					    	console.log('loading content for richtext editor');
							var currentSelectedValue=AJS.$("#jemh-templateset-selection option:selected").val();
							if (currentSelectedValue == '0')
							{
								var custSubject=AJS.$('#defaultCustomSubject').val();
								subjectEditor.getSession().setValue(custSubject);

								var custContent=AJS.$('#defaultCustomContent').val();

								setEditorContent(custContent);
							}
							else
							{
								console.log('loading templateSet '+currentSelectedValue);
								loadRenderedContentforRicheTextEditor(currentSelectedValue, subjectEditor);
							}
					    }
					});
				}
			});

			// attachment drag and drop
			setupDragAndDrop();

			// auto-comment
			AJS.$("#addContentAsComment").change(function(){
				applyAddCommentFieldVisibility();
			});
			applyAddCommentFieldVisibility();

			updateVeloWikiHelpLinkVisibility();
			AJS.$('#customContentMarkup').change(function(ev) {
				if (AJS.$('#content-preview-wrapper').is(":visible"))
				{
					showPreview(contentEditor, "#content-edit-wrapper", "#content-preview-wrapper", AJS.$("#contentType option:selected").val());
				}
				updateVeloWikiHelpLinkVisibility();
			});

			AJS.$('#contentType').change(function(ev) {
				var currentSelectedValue=AJS.$("#jemh-templateset-selection option:selected").val();
				showEditor("#content-edit-wrapper", "#content-preview-wrapper"); //reset editor before updating
				if (currentSelectedValue>0)
				{
					console.log('got contentType change for templateset content, switching out what is being edited');
					var templateSetUrl=AJS.contextPath()+'/rest/jemh/latest/adhoc/download/'+AJS.$("#jemh-templateset-selection option:selected").val()+'?atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content')+'&issueKey='+issueKey;
					var jqXHR=AJS.$.getJSON(templateSetUrl, {
							format: "json"
					});
					jqXHR.done(function(data, textStatus, errorMessage) {
						if(data.errors) {
							console.log('getTemplateSet() errors');
						} else {
							var tsData=data;
							var contentType=AJS.$("#contentType option:selected").val();

							var contentEditorType = AJS.$("#contentEditor").val();
							if (contentEditorType=="advanced")
							{
								if (contentType=='text') {
									//console.log('setting text content with: '+data.text);
									setEditorContent(tsData.text);
								} else {
									//console.log('setting content with: '+data.html);
									setEditorContent(tsData.html);
								}
							}
							else if (contentEditorType=="richtext")
							{
								//ensure we're in HTML mode for richtext
								AJS.$("#contentType").val('html');

								setEditorContent(tsData.html);
							}
						}
					});
				}
			});
			
			// Hook for attachment field changes
			AJS.$('#issueAttachments').on('change', function(e) {
		    	console.log("select2 change : jira issue attachment selection changed, recalculating attachments");
		    	updateAttachmentSizes();
		    });
		
			AJS.$('#jemh-adhoc-staticresources').on('change', function(e){
		    	console.log("static attachment selection changed, recalculating attachments");
		    	updateAttachmentSizes();
			});

			//
			// Kiss mode
			//
			AJS.$('#uiKissMode').change(function(ev) {
				console.log('got change');
				var kissMode=AJS.$("#uiKissMode option:selected").val();
				if (typeof kissMode != "undefined")
				{
					setupKissMode(kissMode);
				}
				else
				{
					console.log("cant locate uiKissMode in UI during change");
				}
			});

			var kissMode=AJS.$("#uiKissMode option:selected").val();
			if (typeof kissMode != "undefined")
			{
				setupKissMode(kissMode);
			}
			else
			{
				console.log("cant locate uiKissMode in UI during start");
			}

			//
			// Setup customfield list -- adhocIssueCustomFieldListForm
			//
			AJS.$('#showAllCustomFields').change(function(ev) {
				console.log('got change - clearing all selects');

				AJS.$(".adhoc-cf-select option").remove();

				//injecting new values
				if(AJS.$("#showAllCustomFields").is(':checked')) {
					console.log('show all');
					var html=AJS.$('#adhocAllIssueCustomFieldList').html();
					AJS.$(".adhoc-cf-select").each(function(index, item) {
						AJS.$(item).html(html);
						AJS.$(item).parent().find('.adhoc-cf-lozenge').text('Unfiltered');
					});
				} else {
					console.log('show filtered');
					var html=AJS.$('#adhocFilteredIssueCustomFieldList').html();
					AJS.$(".adhoc-cf-select").each(function(index, item) {
						AJS.$(item).html(html);
						AJS.$(item).parent().find('.adhoc-cf-lozenge').text('Filtered');
					});
				}
			});

	        showContentEditor(contentEditorType);

			//
			// preload template for type switch
			//
	        var contentEditorType = AJS.$("#defaultContentEditor").val();
			if (contentEditorType=="advanced")
			{
				if (AJS.$("#jemh-templateset-selection option:selected").val() > 0)
				{
					console.log('auto loading template set for editing');
					var templateSetUrl=AJS.contextPath()+'/rest/jemh/latest/adhoc/download/'+AJS.$("#jemh-templateset-selection option:selected").val()+'?atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content')+'&issueKey='+issueKey;
					var jqXHR=AJS.$.getJSON(templateSetUrl, {
							format: "json"
					});
					jqXHR.done(function(data, textStatus, errorMessage) {
						if(data.errors) {
							console.log('getTemplateSet() errors');
						} else {
							tsData=data;
							if (contentType=='text') {
								//console.log('setting text content with: '+data.text);
								setEditorContent(data.text);
							} else {
								//console.log('setting content with: '+data.html);
								setEditorContent(data.html);
							}
						}
					});
				}
			}
			else if (contentEditorType=="richtext")
			{
				//ensure contentype for rendering is set to indicate html
				AJS.$("#contentType").val('html');
			}

			AJS.$(document).keyup(function(e){

			    if(e.keyCode === 27)
			    {
			    	console.log('escape: shutting down editors');
			        shutdown();
			    }
			});

			var adHocForm = AJS.$('form#adHocSubmitForm');

			AJS.$('.textarea#to, #customFieldForTo, #entitiesForTo').change(function(){
				console.log("To recipient change detected!");
				AJS.$(".jemh-adhoc-submit-button").removeAttr('disabled');
				shouldUpdateToRecipient = true;
			});

			AJS.$('.textarea#cc, #customFieldForCc, #entitiesForCc').change(function(){
				console.log("Cc recipient change detected!");
				AJS.$(".jemh-adhoc-submit-button").removeAttr('disabled');
				shouldUpdateCcRecipient = true;
			});

			AJS.$('.textarea#bcc, #customFieldForBcc, #entitiesForBcc').change(function(){
				console.log("Bcc recipient change detected!");
				AJS.$(".jemh-adhoc-submit-button").removeAttr('disabled');
				shouldUpdateBccRecipient = true;
			});

			setUpRecipients(".adhoc-to-recipients-item-tab", "#customFieldForTo option:selected", "#entitiesForTo option:selected", "textarea#to",
					"#adhoc-to-recipients-table", adHocForm);

			setUpRecipients(".adhoc-cc-recipients-item-tab", "#customFieldForCc option:selected", "#entitiesForCc option:selected", "textarea#cc",
					"#adhoc-cc-recipients-table", adHocForm);

			setUpRecipients(".adhoc-bcc-recipients-item-tab", "#customFieldForBcc option:selected", "#entitiesForBcc option:selected", "textarea#bcc",
					"#adhoc-bcc-recipients-table", adHocForm);
	        dialog.show();

			//Adhoc popup settings
			AJS.$('#adhoc-popup-settings').on('click', function() {
				AJS.$('#adhoc-settings-general').show();
				AJS.$('#adhoc-popup-settings').addClass("aui-nav-selected");
			});
		});
	}

	function removeRecipientOperation(event, element) {
	
		var toRecipientTab = "adhoc-to-recipients-table";
        var ccRecipientTab = "adhoc-cc-recipients-table";
        var bccRecipientTab = "adhoc-bcc-recipients-table";
        var adHocForm = AJS.$('form#adHocSubmitForm');

        var recipientTabId =  AJS.$(event.delegateTarget).attr('id');
        var emailElement = event.target.parentElement.previousElementSibling.previousElementSibling;
        var sourceElement = emailElement.nextElementSibling;

        if (recipientTabId === toRecipientTab) {
            adHocForm.append('<input type="hidden" name="disabledToRecipients" value="' + emailElement.innerText + '"/>');
        } else if (recipientTabId === ccRecipientTab) {
            adHocForm.append('<input type="hidden" name="disabledCcRecipients" value="' + emailElement.innerText + '"/>');
        } else if (recipientTabId === bccRecipientTab) {
            adHocForm.append('<input type="hidden" name="disabledBccRecipients" value="' + emailElement.innerText + '"/>');
        }

        AJS.$(element).css('display', 'none');
        AJS.$(element)["0"].nextElementSibling.removeAttribute("style");
        AJS.$(element)["0"].nextElementSibling.style.margin = 0;
        emailElement.style.color = "darkgrey";
        sourceElement.style.color = "darkgrey";
    }

    function addRecipientOperation (event, element) {
        var toRecipientTab = "adhoc-to-recipients-table";
        var ccRecipientTab = "adhoc-cc-recipients-table";
        var bccRecipientTab = "adhoc-bcc-recipients-table";
        var adHocForm = AJS.$('form#adHocSubmitForm');

        var recipientTabId = AJS.$(event.delegateTarget).attr('id');

        var emailElement = event.target.parentElement.previousElementSibling.previousElementSibling;
        var sourceElement = emailElement.nextElementSibling;

        if (recipientTabId === toRecipientTab) {

            AJS.$('input[name=disabledToRecipients]').each(function () {
                if (AJS.$(this).val() === emailElement.innerText) {
                    AJS.$(this).remove();
                }
            });
        } else if (recipientTabId === ccRecipientTab) {
            AJS.$('input[name=disabledCcRecipients]').each(function () {
                if (AJS.$(this).val() === emailElement.innerText) {
                    AJS.$(this).remove();
                }
            });
        } else if (recipientTabId === bccRecipientTab) {
            AJS.$('input[name=disabledBccRecipients]').each(function () {
                if (AJS.$(this).val() === emailElement.innerText) {
                    AJS.$(this).remove();
                }
            });
        }

        AJS.$(element).css('display', 'none');
        AJS.$(element)["0"].previousElementSibling.removeAttribute("style");
        emailElement.removeAttribute("style");
        sourceElement.removeAttribute("style");
    }
    
	function setUpRecipients(recipientTabId, customFieldIdLookUp, entityIdLookUp, textAreaIdLookUp, dataTableLookUp, adHocForm){
		AJS.$(recipientTabId).click(function(event) {
			var shouldUpdate;
			var toRecipientTab = ".adhoc-to-recipients-item-tab";
			var ccRecipientTab = ".adhoc-cc-recipients-item-tab";
			var bccRecipientTab = ".adhoc-bcc-recipients-item-tab";

			if (recipientTabId === toRecipientTab) {
				shouldUpdate = shouldUpdateToRecipient;
			} else if (recipientTabId === ccRecipientTab) {
				shouldUpdate = shouldUpdateCcRecipient;
			} else if (recipientTabId === bccRecipientTab) {
				shouldUpdate = shouldUpdateBccRecipient;
			}

			if (shouldUpdate) {
				event.preventDefault;

				var staticUserStr = AJS.$(textAreaIdLookUp).val().trim();
				var issueObj = AJS.$("#adHocSubmitForm input[name='issueKey']").val();
				var recipientsTable = AJS.$(dataTableLookUp);
				var deleteOperation = "<button class=\"aui-button aui-button-link removeRecipientOperation\">Exclude</button>";
				var addOperation = "<button class=\"aui-button aui-button-link addRecipientOperation\" style=\"display:none\">Include</button>";

				var customFieldData = [];
				var entityData = [];
				if (!AJS.$.fn.DataTable.isDataTable(recipientsTable)) {
					recipientsTable.DataTable();
				}

				AJS.$(customFieldIdLookUp).each(function () {
					customFieldData.push($(this).val());
				});

				AJS.$(entityIdLookUp).each(function () {
					entityData.push($(this).text());
				});

				if (customFieldData.length > 0 || entityData.length > 0 || staticUserStr.length > 0) {
					var getUsersUrl = baseUrl + '/rest/jemh/latest/adhoc/getusers?atl_token=' + AJS.$('#atl_token').val();

					AJS.$.ajax({
						url: getUsersUrl,
						type: 'GET',
						dataType: 'json',
						data: {
							entities: entityData,
							customfield: customFieldData,
							staticlist: staticUserStr,
							issuekey: issueObj
						},
						success: function (response) {
						console.log("Successful getUsers call");
							recipientsTable.empty();
							recipientsTable.dataTable({
								destroy: true,
								data: response,
								columns: [
									{
										width: "80%",
										data: "email"
									},
									{
										width: "10%",
										data: "origin"
									},
									{
										width: "10%",
										render: function () {
											return deleteOperation + addOperation;
										}
									}
								]
							});

                            AJS.$('#tabs-adhoc > .active-pane > .dataTables_wrapper > .dataTable').on('click', '.removeRecipientOperation',function(event){
                                event.preventDefault();
                                removeRecipientOperation(event, this);
                            });

                            AJS.$('#tabs-adhoc > .active-pane > .dataTables_wrapper > .dataTable').on('click', '.addRecipientOperation',function(event){
                                event.preventDefault();
                                addRecipientOperation(event, this);
                             });
						},

						error: function (response) {
							AJS.messages.error("#adhoc-message-context", {
								title: "Failed to get list of recipients",
								body: '<p>Failed to get list of recipients, please consult JEMH logs for more information</p>',
							});
						}
					});
				}

				if (recipientTabId === toRecipientTab) {
					shouldUpdateToRecipient = false;
				} else if (recipientTabId === ccRecipientTab) {
					shouldUpdateCcRecipient = false;
				} else if (recipientTabId === bccRecipientTab) {
					shouldUpdateBccRecipient = false;
				}
			}
		});
	}

    function setupCssStyle( cssStyleSource )
    {
    	AJS.$("#contentCssStyle").val(cssStyleSource);

    	if (cssStyleSource == -1)
    	{
    		console.log("NO CSS will be used for this template");
    	}
    	else if (cssStyleSource===0)
    	{
    		console.log("Default JIRA CSS will be used for this template");
    	}
    	else
    	{
    		console.log("Custom JIRA CSS will be used for this template");
    	}
    }

    function pickAnIssue() {
    	var baseUrl = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '') + AJS.contextPath();
		AJS.$("#jemh-adhoc-issuepicker").remove();
		AJS.$("#jemh-adhoc-issuepicker-dialog").remove();

		var dialog = new AJS.Dialog({
		    width: 400,
		    height: 250,
		    id: "jemh-adhoc-issuepicker-dialog",
		    closeOnOutsideClick: false
		});

	    dialog.addHeader("JEMH Ad-Hoc Notification");

	    var content="<p>Pick an issue to provide context for the notification</p><form class='aui'>";
	    content=content+"<input type='hidden' id='jemh-adhoc-issuepicker' style='width:250px' class='input-xlarge' />";
	    content=content+"<div id='noIssueMsg' style='display:none;color: #d04437;padding-top: 10px;'>Please select a valid issue</div>";
	    content=content+"</form>";

	    dialog.addPanel("Issue Picker", content, "panel-body");
	    dialog.addButton('Submit', function (dialog) { }, 'jemh-adhoc-popup-submit-button');
	    dialog.addLink('Cancel', function (dialog) { dialog.hide(); AJS.$("#jemh-adhoc-issuepicker").remove(); AJS.$("#jemh-adhoc-issuepicker-dialog").remove(); }, 'jemh-adhoc-popup-cancel-button');
	    dialog.show();

	    var url=baseUrl+'/rest/api/2/search';
	    AJS.$("#jemh-adhoc-issuepicker").auiSelect2({
	        placeholder: "Select an issue",
	        minimumInputLength: 3,
	        ajax: {
	            url: url,
	            placeholder: "Search for an Issue",
	            dataType: 'json',
	            minimumInputLength: 1,
	            data: function(term, page) {
	            	//console.log('building query');
	                return {
	                    jql: 'issueKey='+term,
	                    fields : 'issueKey',
	                    maxResults : 10
	                };
	            },
	            results: function(data, page) {
	            	//console.log('got results: '+data.header);
	                return {
	                    results: data.issues,
	                    text: function(item) { return item.key; },
	                    id: function(item) { return item.key; }
	                };
	            }
	        },
	        formatResult: function(item, term)
	        {
	        	//console.log('formatResult: '+item.name);
	        	return item.key;
	        },
	        formatSelection: function(item){
	        	return item.key;
	        },
	        id : function(item) {
	            return item.key;
	        }
	    });

	    AJS.$('#jemh-adhoc-issuepicker').auiSelect2('focus');
	    AJS.tabs.setup();

		AJS.$(".jemh-adhoc-popup-submit-button").click(function(event) {
			var targetIssue=AJS.$('#jemh-adhoc-issuepicker').val();
			if (targetIssue) {
				AJS.$("#jemh-adhoc-issuepicker").remove();
				AJS.$("#jemh-adhoc-issuepicker-dialog").remove();
				dialog.hide();
				console.log('submit -- target issue is: '+targetIssue+' validating enablement and access for current user');
				var checkUri=AJS.contextPath()+'/rest/jemh/latest/adhoc/canLaunch/'+targetIssue+'?atl_token='+AJS.$('meta[name="atlassian-token"]').attr('content');
				AJS.$.get(checkUri)
					.done(function(data, textStatus, errorMessage) {
						handleJemhAdHocNotificationClick(targetIssue);
					}).error(function(data, textStatus, errorMessage) {
						console.error("check() FAIL for : "+targetIssue+", textStatus:"+textStatus+", errorMessage: "+errorMessage);
						AJS.flag({
							type: "error",
							title: "JEMH Ad hoc notification access problem",
							body: "<p>You are able to see the project involved but don't have the required JEMH Ad hoc permission there, please see the project admin.</p>"
						});
					});
			} else {
				AJS.$("#noIssueMsg").hide().show("fast");
			}
			return false;
		});
    }

    //assign global function pointer into this context
    jemhGlobalAdHocFunctionPointer = function() {
    	pickAnIssue();
    };

    //define a function in the current page, that can be called by a keyboard shortcut
    window.jemhJiraAgileAdhocLauncher = function () {
		if (AJS.$("#work-toggle").hasClass('active')) {
			let issue_Key=GH.WorkSelectionController.getSelectedIssueKey();
			console.log("Agile:Work JEMH adhoc launching with work selection: "+issue_Key);
			handleJemhAdHocNotificationClick(issue_Key);
		}
		else if (AJS.$("#plan-toggle").hasClass('active')) {
			let issue_Key=GH.BacklogSelectionController.getSelectedIssueKey();
			console.log("Agile:Plan JEMH adhoc launching with backlog selection: "+issue_Key);
			handleJemhAdHocNotificationClick(issue_Key);
		}
		else
		{
			console.log("JEMH adhoc only supported in work view");
		}
   };

	function serverResponseText(xhr, textStatus){
		let errorBody;
		const responseErrorMessage = ' ' + xhr.status + ' ' + xhr.statusText + ' ';

		errorBody = '<p>The server responded with' + textStatus + htmlEncode(responseErrorMessage) + xhr.responseText + '</p>'

		return errorBody;
	}

	//Order Adhoc templates dropdown by ID
	AJS.$(document).on('click', '#adhoc-template-order-id', function(e) {
		e.preventDefault();
		let orderedOptions;
		let select = AJS.$('#jemh-templateset-selection');
		let button = AJS.$('#adhoc-template-order-id');
		//Get value selected
		let selectedValue = AJS.$("#jemh-templateset-selection option:selected").val();
		//Order
		if (!jemhOrderedId) {
			orderedOptions = AJS.$('#jemh-templateset-selection option');
			orderedOptions.sort(function(a, b) {
				if (a.value > b.value) {
					return 1;
				}
				else if (a.value < b.value) {
					return -1;
				}
				else {
					return 0
				}
			});
			let x = AJS.I18n.getText("jemh.adhoc.templates.id");
			button.html(x + "↑");
		} else {
			orderedOptions = AJS.$('#jemh-templateset-selection option');
			orderedOptions.sort(function(a, b) {
				if (a.value > b.value) {
					return -1;
				}
				else if (a.value < b.value) {
					return 1;
				}
				else {
					return 0
				}
			});
			orderedOptions.toArray().reverse();
			let x = AJS.I18n.getText("jemh.adhoc.templates.id");
			button.html(x + "↓");
		}
		//Set Selected Value again and place at top
		reorderTemplates(select, selectedValue, orderedOptions);
		jemhOrderedId = !jemhOrderedId;
	});

	//Order Adhoc templates dropdown Alphabetically (A-Z, then Z-A)
	AJS.$(document).on('click', '#adhoc-template-order-alphabetical', function(e) {
		e.preventDefault();
		let orderedOptions;
		let select = AJS.$('#jemh-templateset-selection');
		let button = AJS.$('#adhoc-template-order-alphabetical');
		//Get value selected
		let selectedValue = AJS.$("#jemh-templateset-selection option:selected").val();
		//Order
		if (!jemhOrderedAlphabetically) {
			orderedOptions = AJS.$('#jemh-templateset-selection option');
			orderedOptions.sort(function(a, b) {
				if (a.text > b.text) {
					return 1;
				}
				else if (a.text < b.text) {
					return -1;
				}
				else {
					return 0
				}
			});
			let x = AJS.I18n.getText("jemh.adhoc.templates.alphabetical");
			button.html(x + "↑");
		} else {
			orderedOptions = AJS.$('#jemh-templateset-selection option');
			orderedOptions.sort(function(a, b) {
				if (a.text > b.text) {
					return -1;
				}
				else if (a.text < b.text) {
					return 1;
				}
				else {
					return 0
				}
			});
			orderedOptions.toArray().reverse();
			let x = AJS.I18n.getText("jemh.adhoc.templates.alphabetical");
			button.html(x + "↓");
		}
		//Set Selected Value again and place at top
		reorderTemplates(select, selectedValue, orderedOptions);
		jemhOrderedAlphabetically = !jemhOrderedAlphabetically;
	});
});

function reorderTemplates(select, selectedValue, orderedOptions){
	let firstOption = AJS.$('#jemh-templateset-selection option:first');
	AJS.$('#jemh-templateset-selection').val(selectedValue).attr('selected', "selected");
	AJS.$('#jemh-templateset-selection').val(selectedValue).prop('selected', true);
	AJS.$("#jemh-templateset-selection option:selected").insertBefore(firstOption);
	select.append(orderedOptions);
	AJS.$('#jemh-templateset-selection').val(selectedValue).prop('selected', true);
	AJS.$('#jemh-templateset-selection').val(selectedValue).attr('selected', "selected");
}

//Debounce function to prevent repetitive
function debounce(func, wait, immediate) {
	let timeout;
	return function() {
		let context = this, args = arguments;
		let later = function() {
			timeout = null;
			if (!immediate) func.apply(context, args);
		};
		let callNow = immediate && !timeout;
		clearTimeout(timeout);
		timeout = setTimeout(later, wait);
		if (callNow) func.apply(context, args);
	};
}
