AJS.$(document).ready(function() {
    const htmlExtractionMethod ={
        STANDARD_V1: "standard",
        STANDARD_V2: "STANDARD_V2",
    }
    
    function showOrHideThreadMatchFields() {
        const threadMatchLimitValue = AJS.$("#threadMatchLimit").val();

        if (threadMatchLimitValue !== 'notWithResolutions') {
            AJS.$("#threadMatchNotWithResolutions").parent().hide(500);
        } else {
            AJS.$("#threadMatchNotWithResolutions").parent().show(500);
        }

        if (threadMatchLimitValue !== 'matchesJql') {
            AJS.$("#threadMatchJqlQuery").parent().hide(500);
        } else {
            AJS.$("#threadMatchJqlQuery").parent().show(500);
        }
    }

    function showOrHideNbspRemovalOption(){
        const htmlExtractMethodVal = AJS.$("#htmlExtractMethod").val();

        if(htmlExtractMethodVal !== htmlExtractionMethod.STANDARD_V2){
            AJS.$("#removeNbspDiv").parent().hide(500);
        }else{
            AJS.$("#removeNbspDiv").parent().show(500);
        }
    }
    
    function showOrHideProvidedImageAttributesOption(){
        const htmlExtractMethodVal = AJS.$("#htmlExtractMethod").val();

        if(htmlExtractMethodVal === htmlExtractionMethod.STANDARD_V1 || htmlExtractMethodVal === htmlExtractionMethod.STANDARD_V2){
            AJS.$("#isUseProvidedHtmlImageAttributesDiv").parent().show(500);
        }else{
            AJS.$("#isUseProvidedHtmlImageAttributesDiv").parent().hide(500);
        }
    }


    showOrHideThreadMatchFields();
    showOrHideNbspRemovalOption();
    showOrHideProvidedImageAttributesOption();
    AJS.$("#threadMatchLimit").on('change', showOrHideThreadMatchFields);
    AJS.$("#htmlExtractMethod").on('change', showOrHideNbspRemovalOption);
    AJS.$("#htmlExtractMethod").on('change', showOrHideProvidedImageAttributesOption);
});
